unit CursorFunc;

{
    Copyright (C) 2011 Ondrej Pokorny
      http://www.kluug.at
}

{$I OWideSupp.inc}

interface

uses Classes, Windows,
  {$IFDEF O_DELPHI_XE2}
  Vcl.Forms, Vcl.Controls
  {$ELSE}
  Forms, Controls
  {$ENDIF}
  ;

type
  PCursor = ^TCursor;
  TScreenCursors = class(TList)
  public
    procedure SetCursor(Cursor: TCursor);
    procedure SetHourGlassCursor;
    procedure ReleaseLastCursor;

    function FindCursor(aCursorHandle: HICON): TCursor;
  end;

procedure SetScreenHourGlassCursor(out SaveCursor: TCursor);
procedure SetScreenCursor(Cursor: TCursor);
procedure SetScreenCursorSave(Cursor: TCursor; out SaveCursor: TCursor);

function ScreenCursors: TScreenCursors;

implementation

var SC: TScreenCursors;

function ScreenCursors: TScreenCursors;
begin
  if not Assigned(SC) then
    SC := TScreenCursors.Create;
  Result := SC;
end;

procedure SetScreenCursor(Cursor: TCursor);
begin
  Screen.Cursor := Cursor;
  Windows.SetCursor(Screen.Cursors[Cursor]);
end;

procedure SetScreenCursorSave(Cursor: TCursor; out SaveCursor: TCursor);
begin
  SaveCursor := Screen.Cursor;
  SetScreenCursor(Cursor);
end;

procedure SetScreenHourGlassCursor(out SaveCursor: TCursor);
begin
  SetScreenCursorSave(crHourGlass, SaveCursor);
end;

{ TScreenCursors }

function TScreenCursors.FindCursor(aCursorHandle: HICON): TCursor;
var I: Integer;
begin
  for I := crSizeAll to crDefault do
  if Screen.Cursors[I] = aCursorHandle then begin
    Result := TCursor(I);
    exit;
  end;
  Result := crDefault;
end;

procedure TScreenCursors.ReleaseLastCursor;
begin
  if Count > 0 then begin
    SetScreenCursor(TCursor(Items[Count-1]^));
    Dispose(Items[Count-1]);
    Delete(Count-1);
  end;
end;

procedure TScreenCursors.SetCursor(Cursor: TCursor);
var NewCursor: PCursor;
  CS: TCursor;
begin
  SetScreenCursorSave(Cursor, CS);
  New(NewCursor);
  NewCursor^ := CS;
  Add(NewCursor);
end;

procedure TScreenCursors.SetHourGlassCursor;
begin
  SetCursor(crHourGlass);
end;

initialization

  Screen.Cursors[crHandPoint] := LoadCursor(0, IDC_HAND);


end.
