unit OWideSupp;

interface

{$I OWideSupp.inc}

uses SysUtils, Classes,
  {$IFDEF O_DELPHI_XE2}
  Vcl.Dialogs
  {$ELSE}
  Dialogs
  {$ENDIF}

  {$IFDEF O_USE_TNT}, TntClasses, TntDialogs, TntSysUtils{$ENDIF}
  {$IFDEF O_DELPHI_2007UP}, WideStrUtils{$ENDIF}
;

type
  {$IFDEF O_USE_TNT}
    TOWideStrings = TTntStrings;
    TOWideStringList = TTntStringList;

    TOFileStream = TTntFileStream;
    TOWideSaveDialog = TTntSaveDialog;
    TOWideOpenDialog = TTntOpenDialog;

    OWideString = WideString;
    POWideChar = PWideChar;
    OString = String;
  {$ELSE}
    TOWideStrings = TStrings;
    TOWideStringList = TStringList;

    TOFileStream = TFileStream;
    TOWideSaveDialog = TSaveDialog;
    TOWideOpenDialog = TOpenDialog;

    POWideChar = PWideChar;

    {$IFDEF UNICODE}
      OWideString = String;
      OString = UTF8String;
    {$ELSE}
      OWideString = WideString;
      OString = String;
    {$ENDIF}
  {$ENDIF}
  TOWideStringArray = array of OWideString;

function OWideStringReplace(const S, OldPattern, NewPattern: OWideString;
  Flags: TReplaceFlags): OWideString; {$IFDEF O_DELPHI_2007UP}inline;{$ENDIF}

implementation

function OWideStringReplace(const S, OldPattern, NewPattern: OWideString;
  Flags: TReplaceFlags): OWideString;
begin
  {$IFDEF UNICODE}
  Result := StringReplace(S, OldPattern, NewPattern, Flags);
  {$ELSE}
    {$IFDEF O_DELPHI_2007UP}
      Result := WideStringReplace(S, OldPattern, NewPattern, Flags);
    {$ELSE}
      {$IFDEF O_USE_TNT}
        Result := Tnt_WideStringReplace(S, OldPattern, NewPattern, Flags);
      {$ELSE}
        Result := StringReplace(S, OldPattern, NewPattern, Flags);
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
end;

end.
